#/*==========================================================================*
# *    Copyright(c) 2021, Vertiv Tech Co., Ltd.
# *                     ALL RIGHTS RESERVED
# *
# *  PRODUCT  : ACU(Advanced Controller Unit)
# *
# *  FILENAME : Makefile
# *  CREATOR  : Frank Mao                DATE: 2004-09-10 19:29
# *  VERSION  : V1.00
# *  PURPOSE  : The make file for the application service of WEB inteface.
# *
# *  HISTORY  :
# *
# *==========================================================================*/

include $(ACU_SOURCE_DIR)/config_vars.mk

EQ_DIR = $(ACU_SOURCE_DIR)/mainapp/equip_mon
STUB_DIR = $(ACU_SOURCE_DIR)/mainapp/config_mgmt

#the install dir of netscape
#NETSCAPE_DIR = $(HTML_DIR)/netscape
NETSCAPE_DIR = $(WWW_ROOT_DIR)/netscape/pages

NETSCAPE_TEMP_DIR = $(WWW_ROOT_DIR)/netscape/template

NETSCAPE_CGI_DIR = $(WWW_ROOT_DIR)/netscape/cgi-bin

#the target output file
EXEC1 = web_ui_comm.so
EXEC2 = web_cgi_realtime.cgi
EXEC3 = web_cgi_main.cgi
EXEC4 = web_cgi_control.cgi
EXEC5 = web_cgi_query.cgi
EXEC6 = web_cgi_filemanage.cgi
#EXEC7 = web_cgi_multilanguage.so
EXEC8 = web_cgi_setting.cgi

#Added by YangGuoxin,8/23/2006
EXEC9 = web_net_ctrl.cgi
#End by YangGuoxin,8/23/2006

#add netscape support
EXEC10 = web_net_getnms.cgi

#Added by Wankun, 1/11/2007
EXEC11 = web_cgi_query_netscape.cgi
#End by Wankun , 1/11/2007

#add netscape support by YangGuoxin, 3/28/2007
EXEC12 = web_net_setnms.cgi
EXEC13 = web_net_getip.cgi
EXEC14 = web_net_setip.cgi
EXEC15 = web_net_geteem.cgi
EXEC16 = web_net_seteem.cgi

#End by YangGuoxin,3/28/2007

#Added by Wankun, 4/25/2007
EXEC17 = web_cgi_passwd_netscape.cgi
#End by Wankun , 4/25/2007
EXEC18 = web_net_gettime.cgi
EXEC19 = web_net_settime.cgi
EXEC20 = web_net_getlang.cgi
EXEC21 = web_net_setlang.cgi
EXEC22 = web_net_reset.cgi


EXEC = $(EXEC1) $(EXEC2) $(EXEC3) $(EXEC4) $(EXEC5) $(EXEC6) $(EXEC8) $(EXEC9) $(EXEC10) $(EXEC11) $(EXEC12) $(EXEC13) $(EXEC14) $(EXEC15) $(EXEC16) $(EXEC17) $(EXEC18) $(EXEC19) $(EXEC20) $(EXEC21) $(EXEC22)#$(EXEC7) 

#the www dir
WWW_ROOT_DIR=$(ACU_TARGET_DIR)/www

#the install dir of the web pages
HTML_DIR=$(WWW_ROOT_DIR)/html

#the install dir of the CGI
CGI_BIN_DIR=$(HTML_DIR)/cgi-bin/

#the install dir of netscape
#NETSCAPE_DIR = $(HTML_DIR)/netscape
NETSCAPE_DIR = $(WWW_ROOT_DIR)/netscape/pages

NETSCAPE_TEMP_DIR = $(WWW_ROOT_DIR)/netscape/template

NETSCAPE_CGI_DIR = $(WWW_ROOT_DIR)/netscape/cgi-bin

#the install dir of the template

#the head files the object files depend on
INCS :=cgi_realtime.h cgivars.h  cgi_pub.h    communicate.h  # cgi_realtime.h

#the object files to generate the target
OBJS1 = communicate.o cgi_pub.o cgivars.o
OBJS2 = cgi_pub.o cgivars.o   cgi_realtime.o  cgi_suicide_timer.o
OBJS3 = appmain.o cgi_pub.o cgivars.o         cgi_suicide_timer.o
OBJS4 = control_command.o cgi_pub.o cgivars.o cgi_suicide_timer.o
OBJS5 = cgi_query.o cgi_pub.o cgivars.o       cgi_suicide_timer.o
OBJS6 = cgi_filemanage.o  cgi_pub.o cgivars.o cgi_suicide_timer.o
#OBJS7 = cgi_multilanguage.o cgi_pub.o cgivars.o
OBJS8 = cgi_setting.o cgi_pub.o cgivars.o     cgi_suicide_timer.o

#Added by YangGuoxin,8/23/2006
OBJS9 = web_net_control.o cgi_pub.o cgivars.o     cgi_suicide_timer.o
#End by YangGuoxin,8/23/2006

#Added by YangGuoxin,3/15/2007
OBJS10 = web_net_getnms.o cgi_pub.o cgivars.o     cgi_suicide_timer.o
#End by YangGuoxin,3/15/2007

#Added by Wankun, 1/11/2007
OBJS11 = cgi_query_netscape.o cgi_pub.o cgivars.o cgi_suicide_timer.o
#End by Wankun , 1/11/2007

#Added by YangGuoxin,3/28/2007
OBJS12 = web_net_setnms.o cgi_pub.o cgivars.o     cgi_suicide_timer.o
OBJS13 = web_net_getip.o cgi_pub.o cgivars.o     cgi_suicide_timer.o
OBJS14 = web_net_setip.o cgi_pub.o cgivars.o     cgi_suicide_timer.o
OBJS15 = web_net_geteem.o cgi_pub.o cgivars.o     cgi_suicide_timer.o
OBJS16 = web_net_seteem.o cgi_pub.o cgivars.o     cgi_suicide_timer.o
#End by YangGuoxin,3/28/2007

#Added by Wankun, 4/25/2007
OBJS17 = cgi_passwd_netscape.o cgi_pub.o cgivars.o cgi_suicide_timer.o
#End by Wankun , 4/25/2007
OBJS18 = web_net_gettime.o cgi_pub.o cgivars.o     cgi_suicide_timer.o
OBJS19 = web_net_settime.o cgi_pub.o cgivars.o     cgi_suicide_timer.o
OBJS20 = web_net_getlang.o cgi_pub.o cgivars.o     cgi_suicide_timer.o
OBJS21 = web_net_setlang.o cgi_pub.o cgivars.o     cgi_suicide_timer.o
OBJS22 = web_net_reset.o cgi_pub.o cgivars.o     cgi_suicide_timer.o

#   $(ACU_SOURCE_DIR)/lib/publib/run_mutex.o $(ACU_SOURCE_DIR)/lib/publib/run_thread.o $(ACU_SOURCE_DIR)/lib/publib/run_queue.o $(ACU_SOURCE_DIR)/lib/publib/run_timer.o  $(ACU_SOURCE_DIR)/lib/applog/applog.o $(ACU_SOURCE_DIR)/lib/publib/pubfunc.o  $(ACU_SOURCE_DIR)/lib/publib/new.o  

#for self test
CFG_OBJS = $(STUB_DIR)/cfg_load_stdbasic.o 
CFG_OBJS += $(STUB_DIR)/cfg_load_solution.o $(STUB_DIR)/cfg_load_stdequip.o   
CFG_OBJS += $(STUB_DIR)/cfg_loadrun.o $(STUB_DIR)/cfg_loader.o 


EQ_OBJS  = $(EQ_DIR)/equip_mon_main.o $(EQ_DIR)/equip_mon_init.o $(EQ_DIR)/equip_mon_unload.o
EQ_OBJS += $(EQ_DIR)/equip_data_sample.o $(EQ_DIR)/equip_ctrl_cmd.o
EQ_OBJS += $(EQ_DIR)/equip_data_process.o $(EQ_DIR)/equip_exp_eval.o

TEST_EXEC =  test_cgi
TEST_OBJS =  test_cgi.o $(EQ_OBJS) $(CFG_OBJS)
TEST_LIBS =$(EXEC1) -ldl #-lm -lpthread -lrt  #and other required libs


#private shared libraries
LIBS =  -lm -lpthread -lpub  #and other required libs

all: $(EXEC)

$(EXEC1): $(OBJS1) $(INCS) $(PUBINCS)
	$(CC) -shared -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS1) $(LIBS)  $(PUBLIBS) 
	ln -fs `pwd`/$(EXEC1) $(ACU_SOURCE_DIR)/service/$(EXEC1)
	
$(EXEC2): $(OBJS2) $(INCS) $(PUBINCS)
	$(CC) -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS2) $(LIBS)  
	
$(EXEC3): $(OBJS3) $(INCS) $(PUBINCS)
	$(CC) -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS3) $(LIBS)   

$(EXEC4): $(OBJS4) $(INCS) $(PUBINCS)
	$(CC) -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS4) $(LIBS)   

$(EXEC5): $(OBJS5) $(INCS) $(PUBINCS)
	$(CC) -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS5) $(LIBS)   

$(EXEC6): $(OBJS6) $(INCS) $(PUBINCS)
	$(CC) -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS6) $(LIBS) 
	
#$(EXEC7): $(OBJS7) $(INCS) $(PUBINCS)
#	$(CC) -shared -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS7) $(LIBS)   

$(EXEC8): $(OBJS8) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS8) $(LIBS)
	
#Added by YangGuoxin,8/23/2006
$(EXEC9): $(OBJS9) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS9) $(LIBS)  
#End by YangGuoxin,8/23/2006

#Added by YangGuoxin,3/15/2007
$(EXEC10): $(OBJS10) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS10) $(LIBS)  
#End by YangGuoxin,3/15/2007

#Added by Wankun, 1/11/2007
$(EXEC11): $(OBJS11) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS11) $(LIBS)
#End by Wankun , 1/11/2007

#Added by YangGuoxin,3/28/2007
$(EXEC12): $(OBJS12) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS12) $(LIBS)
$(EXEC13): $(OBJS13) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS13) $(LIBS)  
$(EXEC14): $(OBJS14) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS14) $(LIBS)  
$(EXEC15): $(OBJS15) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS15) $(LIBS)  
$(EXEC16): $(OBJS16) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS16) $(LIBS)  				  
#End by YangGuoxin,3/15/2007

#Added by Wankun, 4/25/2007
$(EXEC17): $(OBJS17) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS17) $(LIBS)
#End by Wankun , 4/25/2007
$(EXEC18): $(OBJS18) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS18) $(LIBS)

$(EXEC19): $(OBJS19) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS19) $(LIBS)
	
$(EXEC20): $(OBJS20) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS20) $(LIBS)

$(EXEC21): $(OBJS21) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS21) $(LIBS)

$(EXEC22): $(OBJS22) $(INCS) $(PUBINCS)
	$(CC)  -fPIC $(CFLAGS) $(LDFLAGS) -o $@  $(OBJS22) $(LIBS)  

				
install: $(EXEC)	
	-mkdir -p $(ACU_TARGET_DIR)/service/
	#service interface
	
	-mkdir -p $(CGI_BIN_DIR)/

	cp -fr $(EXEC1) $(ACU_TARGET_DIR)/service/$(EXEC1)
	cp -fr $(EXEC2) $(CGI_BIN_DIR)/$(EXEC2)
	cp -fr $(EXEC3) $(CGI_BIN_DIR)/$(EXEC3)
	cp -fr $(EXEC4) $(CGI_BIN_DIR)/$(EXEC4)
	cp -fr $(EXEC5) $(CGI_BIN_DIR)/$(EXEC5)
	cp -fr $(EXEC6) $(CGI_BIN_DIR)/$(EXEC6)
	#cp -fr $(EXEC7) $(CGI_BIN_DIR)/$(EXEC7)
	cp -fr $(EXEC8) $(CGI_BIN_DIR)/$(EXEC8)
		
	
	#$(STRIP) -s -o $(ACU_TARGET_DIR)/service/$(EXEC1) $(EXEC1)
	chmod +x $(ACU_TARGET_DIR)/service/$(EXEC1)		
	#$(STRIP) -s -o $(CGI_BIN_DIR)/$(EXEC2) $(EXEC2)
	chmod +x $(CGI_BIN_DIR)/$(EXEC2)	
	#$(STRIP) -s -o $(CGI_BIN_DIR)/$(EXEC3) $(EXEC3)
	chmod +x $(CGI_BIN_DIR)/$(EXEC3)	
	#$(STRIP) -s -o $(CGI_BIN_DIR)/$(EXEC4) $(EXEC4)
	chmod +x $(CGI_BIN_DIR)/$(EXEC4)	
	#$(STRIP) -s -o $(CGI_BIN_DIR)/$(EXEC5) $(EXEC5)
	chmod +x $(CGI_BIN_DIR)/$(EXEC5)
	#$(STRIP) -s -o $(CGI_BIN_DIR)/$(EXEC6) $(EXEC6)
	chmod +x $(CGI_BIN_DIR)/$(EXEC6)
	##$(STRIP) -s -o $(CGI_BIN_DIR)/$(EXEC7) $(EXEC7)
	##chmod +x $(CGI_BIN_DIR)/$(EXEC7)
	#$(STRIP) -s -o $(CGI_BIN_DIR)/$(EXEC8) $(EXEC8)
	chmod +x $(CGI_BIN_DIR)/$(EXEC8)
	#NETSCAPE DIR
	-mkdir -p $(NETSCAPE_CGI_DIR)/
	$(STRIP) -s -o $(NETSCAPE_CGI_DIR)/$(EXEC9) $(EXEC9)
	chmod +x $(NETSCAPE_CGI_DIR)/$(EXEC9)
	
	$(STRIP) -s -o $(NETSCAPE_CGI_DIR)/$(EXEC10) $(EXEC10)
	chmod +x $(NETSCAPE_CGI_DIR)/$(EXEC10)
	
	#Added by Wankun, 1/11/2007
	$(STRIP) -s -o $(NETSCAPE_CGI_DIR)/$(EXEC11) $(EXEC11)
	chmod +x $(NETSCAPE_CGI_DIR)/$(EXEC11)
	#End by Wankun , 1/11/2007	

	#Added by YangGuoxin, 3/28/2007
	$(STRIP) -s -o $(NETSCAPE_CGI_DIR)/$(EXEC12) $(EXEC12)
	chmod +x $(NETSCAPE_CGI_DIR)/$(EXEC12)
	
	$(STRIP) -s -o $(NETSCAPE_CGI_DIR)/$(EXEC13) $(EXEC13)
	chmod +x $(NETSCAPE_CGI_DIR)/$(EXEC13)
	$(STRIP) -s -o $(NETSCAPE_CGI_DIR)/$(EXEC14) $(EXEC14)
	chmod +x $(NETSCAPE_CGI_DIR)/$(EXEC14)
	$(STRIP) -s -o $(NETSCAPE_CGI_DIR)/$(EXEC15) $(EXEC15)
	chmod +x $(NETSCAPE_CGI_DIR)/$(EXEC15)
	$(STRIP) -s -o $(NETSCAPE_CGI_DIR)/$(EXEC16) $(EXEC16)
	chmod +x $(NETSCAPE_CGI_DIR)/$(EXEC16)			
	#End by YangGuoxin , 3/28/2007
	
	#Added by Wankun, 4/25/2007
	$(STRIP) -s -o $(NETSCAPE_CGI_DIR)/$(EXEC17) $(EXEC17)
	chmod +x $(NETSCAPE_CGI_DIR)/$(EXEC17)
	#End by Wankun , 4/25/2007	
	$(STRIP) -s -o $(NETSCAPE_CGI_DIR)/$(EXEC18) $(EXEC18)
	chmod +x $(NETSCAPE_CGI_DIR)/$(EXEC18)
	$(STRIP) -s -o $(NETSCAPE_CGI_DIR)/$(EXEC19) $(EXEC19)
	chmod +x $(NETSCAPE_CGI_DIR)/$(EXEC19)

	$(STRIP) -s -o $(NETSCAPE_CGI_DIR)/$(EXEC20) $(EXEC20)
	chmod +x $(NETSCAPE_CGI_DIR)/$(EXEC20)
	$(STRIP) -s -o $(NETSCAPE_CGI_DIR)/$(EXEC21) $(EXEC21)
	chmod +x $(NETSCAPE_CGI_DIR)/$(EXEC21)
	
	$(STRIP) -s -o $(NETSCAPE_CGI_DIR)/$(EXEC22) $(EXEC22)
	chmod +x $(NETSCAPE_CGI_DIR)/$(EXEC22)			
	#
	#html: web pages
	#1. copy tempplate
	-mkdir -p $(HTML_DIR)/template
	-cp -R www/html/web_template/* $(HTML_DIR)/template/
	
	#2. copy loc
	-mkdir -p $(CGI_BIN_DIR)/loc
	#-cp -Rf www/html/loc/* $(CGI_BIN_DIR)/loc/	
	-cp -Rf www/html/loc/* $(HTML_DIR)/template	
	-cp -Rf www/html/loc/j04_gfunc_def.js $(CGI_BIN_DIR)
	-cp -Rf www/html/loc/j09_alai_tree_help.js $(CGI_BIN_DIR)
	-cp -Rf www/html/loc/alai_tree.js $(CGI_BIN_DIR)
	
	-mkdir -p $(NETSCAPE_DIR)
	#-cp -Rf www/html/netscape/* $(NETSCAPE_DIR)
	
	
	-mkdir -p $(NETSCAPE_TEMP_DIR)
	-cp -f www/html/netscape/* $(NETSCAPE_TEMP_DIR)
	
	-chmod 777 $(CGI_BIN_DIR)/loc/* 	
	-chmod 777 $(HTML_DIR)
	-chmod 777 $(NETSCAPE_DIR)
	-chmod 777 $(NETSCAPE_TEMP_DIR)
	
	-mkdir $(CGI_BIN_DIR)/img
	-cp -Rf www/html/loc/img/plus.gif $(CGI_BIN_DIR)/img
	-cp -Rf www/html/loc/img/minus.gif $(CGI_BIN_DIR)/img
	-cp -Rf www/html/loc/img/hfile.gif $(CGI_BIN_DIR)/img
	-cp -Rf www/html/loc/img/hfold_close.gif $(CGI_BIN_DIR)/img
	-cp -Rf www/html/loc/img/hfold_open.gif $(CGI_BIN_DIR)/img
	
	-mkdir $(CGI_BIN_DIR)/eng
	-mkdir $(CGI_BIN_DIR)/eng/img
	-mkdir $(CGI_BIN_DIR)/loc2
	-mkdir $(CGI_BIN_DIR)/loc2/img
	-mkdir $(CGI_BIN_DIR)/loc/img
	-chmod 777 $(CGI_BIN_DIR)/eng
	
	#Add by wj for three languages 2006.4.28
	-chmod 777 $(CGI_BIN_DIR)/loc2
	
	-cp -Rf www/html/loc/img/* $(CGI_BIN_DIR)/eng/img
	-cp -Rf www/html/loc/img/* $(CGI_BIN_DIR)/loc/img
	-cp -Rf www/html/loc/img/* $(CGI_BIN_DIR)/loc2/img
	
	-mkdir -p $(NETSCAPE_DIR)/img
	-cp -Rf www/html/netscape/img/* $(NETSCAPE_DIR)/img

	#3. cp the startwebd script file.
	-mkdir $(ACU_TARGET_DIR)/bin
	-cp startwebd	$(ACU_TARGET_DIR)/bin/startwebnewd
	-dos2unix $(ACU_TARGET_DIR)/bin/startwebnewd
	-chmod 755 $(ACU_TARGET_DIR)/bin/startwebnewd

	#4. cp the firstpage.htm file
	-mkdir $(WWW_ROOT_DIR)/index
	-cp -f www/html/loc/firstpage.htm $(WWW_ROOT_DIR)/

$(TEST_EXEC): $(EXEC) $(TEST_OBJS) $(PUBLIBS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(TEST_OBJS) $(TEST_LIBS) $(PUBLIBS)
			
	
test: $(TEST_EXEC)
	-echo Test making ...

clean:
	-rm -f $(EXEC) *.gdb *.elf *.o $(OBJS) core $(TEST_EXEC)
	-rm -f make_*.txt *.map
	-rm -f $(ACU_SOURCE_DIR)/service/$(EXEC1)

	


